//
// file      : mdm_drv.c.c
// author    : Ian Forse
// date      : 2002-10-24
// purpose   : Display driver demo on MDM-1
// includes  : 16f877.h, dly_cc5x.h, dly_cc5x.c, mdm_cc5x.c, mdm_cc5x.h mdm_demo_cc5x.c
// notes     : 
// compiler  : CC5X V3.1f Free Edition C Compiler from BKD
//
// Copyright (C) 2002 Ian Forse
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
// USA


#include "16f877.h"
#define CP_off |= 0x3F30
#pragma chip PIC16F877
#pragma config CP_off, PWRTE=on, WDTE=off, FOSC=HS, BODEN=on

// LOAD,DATA & CLOCK use Portb,2,4,5 respectively
#pragma bit mdm_pin_load @ PORTB.2
#pragma bit mdm_pin_data @ PORTB.4
#pragma bit mdm_pin_clock @ PORTB.5
#pragma bit RD7 @ PORTD.7

#pragma bit mdm_pin_load_direction @ TRISB.2
#pragma bit mdm_pin_data_direction @ TRISB.4
#pragma bit mdm_pin_clock_direction @ TRISB.5
#pragma bit mode_select_direction @ TRISD.7

#include "dly_cc5x.c"
#include "dly_cc5x.h"
#include "mdm_cc5x.h"
#include "mdm_cc5x.c"
#include "mdm_demo_cc5x.c"

void main(void)
{
mode_select_direction = 1;
ADCON1 = 0b1000.0000;
ADCON0 = 0b0100.0001;	// ADC Channel 0
mdm_init();

	while(1)
	{
	   if (RD7 == 0)
	   {
	      ADIE = 0;		// Masking the interrupt
	      ADIF = 0;		// Resetting the ADC interupt bit					
	      ADRESL = 0; 		// Resetting the ADRES value register
	      ADRESH = 0; 						 
	      GO = 1;
					  	// Staring the ADC process
	        while(!ADIF) continue;	// Wait for conversion complete		
			
		unsigned char a;	
		mdm_write_p (1, '0');
		a = ADRESH & 0x0f;
		if ( a < 10 )
		{
		   a = a + 48; // Convert 0 - 9 from HEX to ASCII
		}
		else
		{
		   a = a + 55; // Convert A - F from HEX to ASCII			
		}
		mdm_write_p (2, a);
				a = (ADRESL >>4) & 0x0f;
		if ( a < 10 )
		{
		   a = a + 48; // Convert 0 - 9 from HEX to ASCII
		}
		else
		{
		   a = a + 55; // Convert A - F from HEX to ASCII
		}
		mdm_write_p (3, a);
				a = ADRESL & 0x0f;
		if ( a < 10 )
		{
		   a = a + 48; // Convert 0 - 9 from HEX to ASCII
		}
		else
		{
		   a = a + 55; // Convert A - F from HEX to ASCII			
		}
		mdm_write_p (4,a);
		mdm_write_p (5,'h');
		DelayMs(250);
		}

		else
		{
		blink();
		show_12345();
		blank();    
		show_ascii(); 
		blank();
		show_hello();
		blank();
		}
	}
}
